# Generated by Django 3.2.4 on 2021-07-01 10:11

import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import django_json_field_schema_validator.validators
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='EnteCreditore',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True, verbose_name='Identificativo ente creditore')),
                ('denominazione', models.CharField(max_length=70, verbose_name='Denominazione Ente creditore')),
                ('cf', models.CharField(max_length=35, verbose_name='CF Ente creditore')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='Data di creazione')),
                ('updated_at', models.DateTimeField(auto_now=True, verbose_name='Data ultimo aggiornamento')),
            ],
            options={
                'verbose_name': 'Ente creditore',
                'verbose_name_plural': 'Enti creditori',
                'ordering': ['created_at'],
            },
        ),
        migrations.CreateModel(
            name='ListaDiCarico',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True, verbose_name='Identificativo lista di carico')),
                ('id_messaggio', models.CharField(max_length=35, verbose_name='Identificativo messaggio')),
                ('codice_versamento', models.CharField(max_length=4, verbose_name='Codice versamento')),
                ('numero_posizioni_debitorie', models.PositiveIntegerField(validators=[django.core.validators.MinValueValidator(1), django.core.validators.MaxValueValidator(999999)], verbose_name='Numero posizioni debitorie')),
                ('importo_totale', models.DecimalField(decimal_places=2, max_digits=10, validators=[django.core.validators.MinValueValidator(0.0), django.core.validators.MaxValueValidator(99999999.99)], verbose_name='Importo totale lista di carico')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='Data di creazione')),
                ('updated_at', models.DateTimeField(auto_now=True, verbose_name='Data ultimo aggiornamento')),
                ('ente_creditore', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='ppay.entecreditore', verbose_name='Ente creditore')),
            ],
            options={
                'verbose_name': 'Lista di carico',
                'verbose_name_plural': 'Liste di carico',
                'ordering': ['created_at'],
            },
        ),
        migrations.CreateModel(
            name='PosizioneDebitoria',
            fields=[
                ('id', models.UUIDField(default=uuid.uuid4, editable=False, primary_key=True, serialize=False, unique=True, verbose_name='Identificativo Posizione debitoria da inserire')),
                ('id_posizione_debitoria', models.CharField(max_length=50, unique=True, verbose_name='Identificativo della posizione debitoria')),
                ('anno_riferimento', models.PositiveIntegerField(blank=True, null=True, validators=[django.core.validators.MinValueValidator(2000), django.core.validators.MaxValueValidator(2100)], verbose_name='Anno di riferimento')),
                ('totale', models.PositiveIntegerField(validators=[django.core.validators.MinValueValidator(1)], verbose_name='Importo totale')),
                ('scadenza', models.DateField(null=True, verbose_name='Data di scadenza')),
                ('inizio_validita', models.DateField(blank=True, null=True, verbose_name='Data di inizio validità')),
                ('fine_validita', models.DateField(blank=True, null=True, verbose_name='Data di fine validità')),
                ('causale', models.CharField(max_length=100, verbose_name='Descrizione causale versamento')),
                ('rata', models.CharField(blank=True, max_length=16, null=True, verbose_name='Descrizione rata')),
                ('componenti_importo', models.JSONField(blank=True, null=True, validators=[django_json_field_schema_validator.validators.JSONFieldSchemaValidator({'$schema': 'http://json-schema.org/draft-07/schema#', 'items': {'properties': {'anno_accertamento': {'maxValue': 2100, 'minValue': 2000, 'type': 'integer'}, 'causale_descrittiva': {'maxLength': 80, 'type': 'string'}, 'dati_specifici_riscossione': {'maxLength': 140, 'pattern': '^[0129]{1}/\\S{3,138}$', 'type': 'string'}, 'importo': {'maxValue': 99999999.99, 'minValue': 0.0, 'multipleOf': 0.01, 'type': 'number'}, 'numero_accertamento': {'maxLength': 35, 'type': 'string'}}, 'required': ['importo', 'causale_descrittiva'], 'type': 'object'}, 'maxItems': 5, 'type': 'array'})], verbose_name='Componenti importo')),
                ('riferimenti_pagamento', models.JSONField(blank=True, null=True, validators=[django_json_field_schema_validator.validators.JSONFieldSchemaValidator({'$schema': 'http://json-schema.org/draft-07/schema#', 'items': {'properties': {'nome': {'maxLength': 70, 'type': 'string'}, 'valore': {'maxLength': 70, 'type': 'string'}}, 'required': ['nome', 'valore'], 'type': 'object'}, 'maxItems': 5, 'type': 'array'})], verbose_name='Riferimenti pagamento')),
                ('note', models.CharField(blank=True, max_length=100, null=True, verbose_name='Note per il pagatore')),
                ('soggetto_pagatore_name', models.CharField(blank=True, max_length=70, null=True, verbose_name='Nome soggetto pagatore (persona fisica)')),
                ('soggetto_pagatore_surname', models.CharField(blank=True, max_length=70, null=True, verbose_name='Cognome soggetto pagatore (persona fisica)')),
                ('ragione_sociale', models.CharField(blank=True, max_length=70, null=True, verbose_name='Ragione sociale (persona giuridica)')),
                ('identificativo_univoco_fiscale', models.CharField(max_length=35, verbose_name='Identificativo univoco fiscale soggetto pagatore')),
                ('indirizzo', models.CharField(blank=True, max_length=70, null=True, verbose_name='Indirizzo soggetto oagatore')),
                ('civico', models.CharField(blank=True, max_length=16, null=True, verbose_name='Numero civico soggetto oagatore')),
                ('cap', models.CharField(blank=True, max_length=16, null=True, verbose_name='CAP soggetto oagatore')),
                ('localita', models.CharField(blank=True, max_length=35, null=True, verbose_name='Località soggetto oagatore')),
                ('provincia', models.CharField(blank=True, max_length=35, null=True, verbose_name='Provincia soggetto oagatore')),
                ('nazione', models.CharField(blank=True, max_length=2, null=True, validators=[django.core.validators.RegexValidator('[A-Z]{2}')], verbose_name='Nazione soggetto oagatore')),
                ('email', models.EmailField(blank=True, max_length=256, null=True, validators=[django.core.validators.RegexValidator('.+@.+')], verbose_name='Email soggetto oagatore')),
                ('iuv', models.CharField(blank=True, max_length=35, null=True, verbose_name='Identificativo univoco versamento')),
                ('codice_avviso', models.CharField(blank=True, max_length=35, null=True, verbose_name='Codice avviso di pagamento')),
                ('codice_esito', models.CharField(blank=True, max_length=3, null=True, validators=[django.core.validators.RegexValidator('[012][0-9]{2}')], verbose_name='Codice esito inserimento')),
                ('descrizione_esito', models.CharField(blank=True, max_length=200, null=True, verbose_name='Descrizione esito inserimento')),
                ('created_at', models.DateTimeField(auto_now_add=True, verbose_name='Data di creazione')),
                ('updated_at', models.DateTimeField(auto_now=True, verbose_name='Data ultimo aggiornamento')),
                ('lista_di_carico', models.ForeignKey(on_delete=django.db.models.deletion.PROTECT, to='ppay.listadicarico', verbose_name='Lista di carico')),
            ],
            options={
                'verbose_name': 'Posizione debitoria da inserire',
                'verbose_name_plural': 'Posizioni debitorie da inserire',
                'ordering': ['created_at'],
            },
        ),
    ]
